BeginPackage["CSM`ComplexParametricPlot`"]

ComplexParametricPlot::usage =
	"ComplexParametricPlot[z, {t, t0, t1}] plots a complex parametric line.
	ComplexParametricPlot[z, {t, t0, t1}, {r, r0, r1, dr}] plot several lines."

Begin["`Private`"]

ComplexParametricPlot[z_, range_List]:=
    ParametricPlot[{Re[z],Im[z]}, range]

ComplexParametricPlot[z_, range_List, table_List]:=
    ParametricPlot[Evaluate[Table[{Re[z],Im[z]}, table]], range]

End[]

EndPackage[]
